package com.banesco.module.docservice_file_audit_trace.application.service;

import com.banesco.common.application.helper.MessageHelper;
import com.banesco.common.domain.exception.*;
import com.banesco.common.domain.model.*;
import com.banesco.module.docservice_file_audit_trace.application.repository.ApiPrivateRepository;
import com.banesco.module.docservice_file_audit_trace.application.usecase.DocserviceFileAuditTraceUseCase;
import com.banesco.module.docservice_file_audit_trace.domain.dto.request.DocserviceFileAuditTraceRequest;
import com.banesco.module.docservice_file_audit_trace.domain.dto.response.DocserviceFileAuditTraceResponse;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.inject.Inject;
import jakarta.ws.rs.core.Response;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@ApplicationScoped
public class DocserviceFileAuditTraceService implements DocserviceFileAuditTraceUseCase {

    private final MessageHelper messageHelper;
    private final ApiPrivateRepository apiPrivateRepository;

    @Inject
    public DocserviceFileAuditTraceService(
        MessageHelper messageHelper,
        ApiPrivateRepository apiPrivateRepository
    ) {
        this.messageHelper = messageHelper;
        this.apiPrivateRepository = apiPrivateRepository;
    }

    @Override
    public Response execute(
        DocserviceFileAuditTraceRequest request
    ) {
        log.info("Iniciando ejecucion para el archivo: {}", request.getDocumentName());

        Response response;

        try {
            ApiResponse<DocserviceFileAuditTraceResponse> apiResponse = apiPrivate(request);

            response = messageHelper.handleSuccess(
                apiResponse.getData(),
                apiResponse.getStatusResponse().getStatusCode()
            );
        } catch (ApiPrivateException e) {
            log.warn("Excepcion de la api privada: {} -> {}", e.getStatusCode(), e.getMessage());
            response = messageHelper.handleException(HttpStatusCodeException.conflict(e.getStatusCode()));
        } catch (HttpStatusCodeException e) {
            log.error("Excepcion HTTP del api privada: {} - {}", e.getStatusCode(), e.getErrorCode());
            response = messageHelper.handleException(e);
        } catch (Exception e) {
            log.error("Excepcion generica del api privada: {}", e.getMessage());
            response = messageHelper.handleGenericException(e);
        }

        return response;
    }

    private ApiResponse<DocserviceFileAuditTraceResponse> apiPrivate(
        DocserviceFileAuditTraceRequest request
    ) {
        log.info("Ejecutando llamada al api privada: {}", request.getDocumentName());

        return new ApiResponse<>(
            DocserviceFileAuditTraceResponse.builder()
                .documentService(apiPrivateRepository.execute(request))
                .build(),
            messageHelper.createStatusResponse("200")
        );
    }
}